package cn.com.infosec.crypto.agreement;

import cn.com.infosec.crypto.BasicAgreement;
import cn.com.infosec.crypto.CipherParameters;
import cn.com.infosec.crypto.params.AsymmetricKeyParameter;
import cn.com.infosec.crypto.params.DHParameters;
import cn.com.infosec.crypto.params.DHPrivateKeyParameters;
import cn.com.infosec.crypto.params.DHPublicKeyParameters;
import cn.com.infosec.crypto.params.ParametersWithRandom;
import java.math.BigInteger;

public class DHBasicAgreement implements BasicAgreement {
   private DHPrivateKeyParameters key;
   private DHParameters dhParams;

   public void init(CipherParameters param) {
      AsymmetricKeyParameter param1;
      if (param instanceof ParametersWithRandom) {
         param1 = (AsymmetricKeyParameter)((ParametersWithRandom)param).getParameters();
      } else {
         param1 = (AsymmetricKeyParameter)param;
      }

      if (param1 instanceof DHPrivateKeyParameters) {
         DHBasicAgreement var10000 = this;
         DHPrivateKeyParameters var2;
         this.key = var2 = (DHPrivateKeyParameters)param1;
         var10000.dhParams = var2.getParameters();
      } else {
         throw new IllegalArgumentException("DHEngine expects DHPrivateKeyParameters");
      }
   }

   public BigInteger calculateAgreement(CipherParameters pubKey) {
      DHPublicKeyParameters pubKey1;
      if ((pubKey1 = (DHPublicKeyParameters)pubKey).getParameters().equals(this.dhParams)) {
         return pubKey1.getY().modPow(this.key.getX(), this.dhParams.getP());
      } else {
         throw new IllegalArgumentException("Diffie-Hellman public key has wrong parameters.");
      }
   }
}
